SystemOrganization addCategory: #Perspectives!
SystemOrganization addCategory: #'Perspectives-Tests'!
SystemOrganization addCategory: #'Perspectives-Visualization'!

Morph subclass: #PPieceMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PPieceMorph methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 13:50'!
adjustSize
	self extent: 100@200! !

!PPieceMorph methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 13:50'!
initialize
	super initialize.
	self color: Color blue.
	self adjustSize! !

SystemWindow subclass: #PVisualizer
	instanceVariableNames: 'window list pane steps selectedStep signalId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PVisualizer class methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:47'!
open
	^ self new open! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 23:33'!
accept: text
	"ignore"! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:19'!
addStep: aStep
	steps addStep: aStep.
	self selectStep: steps size! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:14'!
connectSignal
	signalId := Piece onInstanceCreation: [ :piece | self pieceCreated: piece ]! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/14/2011 14:47'!
createChildren
	| htop hbottom wleft |
	htop := 0.2.
	hbottom := 0.2.
	wleft := 0.3.
	window
		addMorph: self createUpperPane frame: (0@0 corner: 1@htop);
		addMorph: self createList frame: (0@htop corner: wleft@(1-hbottom));
		addMorph: self createPane frame: (wleft@htop corner: 1@(1-hbottom));
		addMorph: self createLowerPane frame: (0@(1-hbottom) corner: 1@1)! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/16/2011 22:55'!
createList
	^ (list := PluggableListMorph
		on: self
		list: #steps
		selected: #selectedStep
		changeSelected: #selectStep:)
			color: Color white;
			yourself
		! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/16/2011 23:31'!
createLowerPane
	^ PluggableTextMorphPlus
		on: self
		text: #name
		accept: #accept:! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/29/2011 14:28'!
createPane
	^ pane := PStepsPane new
		color: Color white;
		yourself! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/16/2011 23:36'!
createUpperPane
	| text |
	text := PluggableTextMorphPlus
		on: self
		text: #d
		accept: #accept:.
	text wantsFrameAdornments: false.
	text styler: (SHTextStylerST80 new view: text; yourself).
	text textMorph editor model: self.
	^ text! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/14/2011 14:56'!
createWindow
	window := SystemWindow new.
	window
		model: self;
		setLabel: 'PVisualizer';
		setWindowColor: self defaultColor.
	self
		createChildren! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:48'!
d
	 ^ '(PerspectiveObject1 new @ TestLayer) name'! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/16/2011 23:05'!
disconnectSignal
	signalId ifNotNil: [
		Piece disconnect: signalId.
		signalId := nil
	]! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:14'!
doItContext
	^ nil! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 23:43'!
doItReceiver
	^ self ! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 23:04'!
finalize
	self disconnectSignal! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:46'!
found: aCompiledMethod for: aPiece
	self addStep: (PFoundStep on: aPiece with: aCompiledMethod)! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:27'!
initialize
	super initialize.
	steps := PStepList new.
	self createWindow.
	self connectSignal.! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:47'!
lookingUp: aSelector for: aPiece
	self addStep: (PLookUpStep on: aPiece with: aSelector)! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:48'!
open
	"window openInWorldExtent: 800@600"
	window openInWorld! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:36'!
pieceCreated: piece
	self addStep: (PInstanceCreationStep on: piece).
	piece pieceImplementation methodDispatcher
		onLookingUp: [ :selector | self lookingUp: selector for: piece ];
		onSearching: [ :class | self searching: class for: piece ];
		onFound: [ :method |  self found: method for: piece ];
		onHiddenMethod: [ "self hiddenMethod" ]! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:47'!
searching: aClass for: aPiece
	self addStep: (PSearchingStep on: aPiece with: aClass)! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:23'!
selectStep: anIndex
	selectedStep := anIndex.
	list updateList.
	pane selectStep: anIndex! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:13'!
selectedClass
	^ self class! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/16/2011 22:54'!
selectedStep
	^ selectedStep ifNil: [0]! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:19'!
steps
	^ steps steps! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 22:58'!
windowIsClosing
	self disconnectSignal! !

TestCase subclass: #TestPerspectives
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testDirectPerspectiveCall
	| object |
	object := PerspectiveObject1 new.
	self assert: [ object returnValue = 42 ].
	self assert: [ (object @ nil) returnValue = 42 ].
	self assert: [ (object @ TestLayer) returnValue = 23 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testDoesNotUnderstand
	| object |
	object := PerspectiveObject1 new.
	self should: [ object foo ] raise: MessageNotUnderstood.
	self should: [ (object @ nil) foo ] raise: MessageNotUnderstood.
	self should: [ (object @ TestLayer) foo ] raise: MessageNotUnderstood.! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:42'!
testHiddenMethod
	| object |
	object := PerspectiveObject1 new.
	object method1.
	(object @ TestLayer) method1.
	self should: [ (object @ TestChildLayer) method1 ] raise: MessageNotUnderstood.! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testIdentityInvariant
	| object |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestLayer) = (object @ TestChildLayer) ].
	self assert: [ (object @ TestLayer) = object ].
	self assert: [ object = (object @ TestLayer) ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testIndirectPerspectiveCall
	| object |
	object := PerspectiveObject1 new.
	self assert: [ object callReturnValue = 42 ].
	self assert: [ (object @ TestLayer) callReturnValue = 23 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:41'!
testLayerSwitching
	| object  |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestChildLayer @ TestLayer) returnValue = 23 ].
	self assert: [ (object @ TestLayer @ TestChildLayer) returnValue = 15 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:46'!
testParentLayer
	| object  |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestLayer) returnValue = 23 ].
	self assert: [ (object @ TestChildLayer) returnValue = 15 ].
	
	self assert: [ (object @ TestLayer) isTestLayer ].
	self assert: [ (object @ TestChildLayer) isTestLayer ].
	
	self assert: [ (object @ TestChildLayer) isTestChildLayer ].
	self should: [ (object @ TestLayer) isTestChildLayer ] raise: MessageNotUnderstood.
	! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:56'!
testProceed
	| object  |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestLayer) someValue = 100 ].
	self assert: [ (object @ TestChildLayer) someValue = 200 ].
	! !

Object subclass: #AbstractMethodDispatcher
	instanceVariableNames: 'lookupClass signalHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!AbstractMethodDispatcher methodsFor: 'signal-emitting' stamp: 'RL 12/16/2011 20:08'!
found: aCompiledMethod
	^ signalHandler emit: #found with: aCompiledMethod! !

!AbstractMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:25'!
inClassHierarchyLookupSelector: aSelector
	| class |
	class := lookupClass.
	[ class isNil ] whileFalse: [
		self searching: class.
		(class includesSelector: aSelector) ifTrue: [ ^ (class compiledMethodAt: aSelector) method ].
		class := class superclass
	].
	^ nil! !

!AbstractMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:02'!
initialize
	super initialize.
	signalHandler := PSignalHandler new! !

!AbstractMethodDispatcher methodsFor: 'signal-emitting' stamp: 'RL 12/29/2011 13:13'!
lookingUp: aSelector
	^ signalHandler emit: #lookingUp with: aSelector! !

!AbstractMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:32'!
lookupClass
	^ lookupClass! !

!AbstractMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:32'!
lookupClass: aClass
	lookupClass := aClass! !

!AbstractMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:13'!
lookupSelector: aSelector
	| method |
	self lookingUp: aSelector.
	method := self privateLookupSelector: aSelector.
	self found: method.
	^ method! !

!AbstractMethodDispatcher methodsFor: 'dispatch' stamp: 'RL 12/29/2011 12:18'!
on: receiver doesNotUnderstand: selector withArguments: arguments
	^ receiver doesNotUnderstand: 
		((Message selector: selector arguments: arguments)
			lookupClass: lookupClass;
			yourself)! !

!AbstractMethodDispatcher methodsFor: 'dispatch' stamp: 'RL 12/29/2011 12:20'!
on: receiver perform: selector withArguments: arguments
	| method result oldDispatcher |
	method := (self lookupSelector: selector)
		ifNil: [ ^ self on: receiver doesNotUnderstand: selector withArguments: arguments ].
	oldDispatcher := receiver methodDispatcher.
	receiver methodDispatcher: self.
	result := receiver withArgs: arguments executeMethod: method.
	receiver methodDispatcher: oldDispatcher.
	^ result! !

!AbstractMethodDispatcher methodsFor: 'signals' stamp: 'RL 12/16/2011 20:09'!
onFound: aBlock
	^ signalHandler connect: #found to: aBlock! !

!AbstractMethodDispatcher methodsFor: 'signals' stamp: 'RL 12/16/2011 20:10'!
onLookingUp: aBlock
	^ signalHandler connect: #lookingUp to: aBlock! !

!AbstractMethodDispatcher methodsFor: 'signals' stamp: 'RL 12/16/2011 20:09'!
onSearching: aBlock
	^ signalHandler connect: #searching to: aBlock! !

!AbstractMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:12'!
privateLookupSelector: aSelector
	self subclassResponsibility! !

!AbstractMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 13:02'!
proceed
	^ self error: 'Not yet implemented'! !

!AbstractMethodDispatcher methodsFor: 'signal-emitting' stamp: 'RL 12/29/2011 13:10'!
searching: aPerspectiveOrClass
	^ signalHandler emit: #searching with: aPerspectiveOrClass! !

!AbstractMethodDispatcher methodsFor: 'dispatch' stamp: 'RL 12/8/2011 22:09'!
sendMessage: aMessage to: receiver
	^ self on: receiver perform: aMessage selector withArguments: aMessage arguments! !

!AbstractMethodDispatcher methodsFor: 'signals' stamp: 'RL 12/16/2011 20:03'!
signalHandler
	^ signalHandler! !

AbstractMethodDispatcher subclass: #DefaultMethodDispatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!DefaultMethodDispatcher class methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:33'!
for: aClass
	^ self new
		lookupClass: aClass;
		yourself! !

!DefaultMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:12'!
privateLookupSelector: aSelector
	^ self inClassHierarchyLookupSelector: aSelector! !

AbstractMethodDispatcher subclass: #PerspectiveMethodDispatcher
	instanceVariableNames: 'perspective'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PerspectiveMethodDispatcher class methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:35'!
for: aClass from: aPerspective
	^ self new
		lookupClass: aClass;
		perspective: aPerspective;
		yourself! !

!PerspectiveMethodDispatcher methodsFor: 'signal-emitting' stamp: 'RL 12/16/2011 20:29'!
hiddenMethod
	signalHandler emit: #hiddenMethod! !

!PerspectiveMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:25'!
inPerspectiveHierarchyLookupSelector: aSelector
	| p |
	p := perspective.
	[ p isNil ] whileFalse: [
		self searching: p.
		(p includesSelector: aSelector) ifTrue: [ ^ p compiledMethodAt: aSelector ].
		p := p parentLayer
	].
	^ nil! !

!PerspectiveMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:19'!
isHidden: aMethod
	^ aMethod
		ifNil: [ false ]
		ifNotNil: [ :method |
			method pragmas
				anySatisfy: [ :pragma | pragma arguments
					anySatisfy: [ :arg | arg = #hide ] ] ]! !

!PerspectiveMethodDispatcher methodsFor: 'signals' stamp: 'RL 12/16/2011 20:28'!
onHiddenMethod: aBlock
	^ signalHandler connect: #hiddenMethod to: aBlock! !

!PerspectiveMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:33'!
perspective
	^ perspective! !

!PerspectiveMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:33'!
perspective: aPerspective
	perspective := aPerspective! !

!PerspectiveMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:29'!
privateLookupSelector: aSelector
	| method |
	method := self inPerspectiveHierarchyLookupSelector: aSelector.
	(self isHidden: method) ifTrue: [
		self hiddenMethod.
		^ nil ].
	method ifNil: [ method := self inClassHierarchyLookupSelector: aSelector ].
	^ method! !

Object subclass: #PSignal
	instanceVariableNames: 'callbacks nextId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:45'!
connect: aBlock
	| id |
	id := nextId.
	callbacks at: id put: aBlock.
	nextId := nextId + 1.
	^ id
	! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:45'!
disconnect: anId
	^ callbacks removeKey: anId ifAbsent: []! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:40'!
disconnectAll
	^ callbacks removeAll! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:34'!
emit
	self emitWithArguments: #()! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:36'!
emitWith: arg1
	self emitWithArguments: (Array with: arg1)! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:36'!
emitWith: arg1 with: arg2
	self emitWithArguments: (Array with: arg1 with: arg2)! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:36'!
emitWith: arg1 with: arg2 with: arg3
	self emitWithArguments: (Array with: arg1 with: arg2 with: arg3)! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:57'!
emitWithArguments: arguments
	callbacks do: [ :callback | 
		callback valueWithArguments: (self resizeArguments: arguments toFit: callback argumentCount)
	]! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:28'!
initialize
	super initialize.
	callbacks := Dictionary new.
	nextId := 0.! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:40'!
resizeArguments: arguments toFit: aSize
	| newArgs |
	newArgs := Array new: aSize.
	1 to: aSize do: [ :i |
		newArgs at: i put: (arguments at: i ifAbsent: [ nil ])
	].
	^ newArgs! !

Object subclass: #PSignalHandler
	instanceVariableNames: 'signals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:46'!
connect: signalName to: aBlock
	^ ( signals at: signalName ifAbsentPut: [ PSignal new ])
		connect: aBlock! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:46'!
disconnect: signalName from: anId
	(signals at: signalName ifAbsent: [ ^ self ]) disconnect: anId! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:47'!
emit: signalName
	 (signals at: signalName ifAbsentPut: [ ^ self ]) emit! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:05'!
emit: signalName with: arg1
	 (signals at: signalName ifAbsentPut: [ ^ self ])
		emitWithArguments: (Array with: arg1)! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:05'!
emit: signalName with: arg1 with: arg2
	 (signals at: signalName ifAbsentPut: [ ^ self ])
		emitWithArguments: (Array with: arg1 with: arg2)! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:05'!
emit: signalName with: arg1 with: arg2 with: arg3
	 (signals at: signalName ifAbsentPut: [ ^ self ])
		emitWithArguments: (Array with: arg1 with: arg2 with: arg3)! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:47'!
emit: signalName withArguments: arguments
	 (signals at: signalName ifAbsentPut: [ ^ self ]) emitWithArguments: arguments! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:36'!
initialize
	super initialize.
	signals := Dictionary new! !

Object subclass: #PStep
	instanceVariableNames: 'piece'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

PStep subclass: #PFoundStep
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PFoundStep class methodsFor: 'instance creation' stamp: 'RL 12/29/2011 14:45'!
on: aPiece with: aMethod
	^ self new
		piece: aPiece;
		method: aMethod;
		yourself! !

!PFoundStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:45'!
method
	^ method! !

!PFoundStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:45'!
method: aMethod
	method := aMethod! !

!PFoundStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:52'!
printOn: aStream
	aStream
		nextPutAll: 'found method in: ';
		nextPutAll: method methodClass name
	! !

PStep subclass: #PInstanceCreationStep
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PInstanceCreationStep class methodsFor: 'instance creation' stamp: 'RL 12/29/2011 14:28'!
on: aPiece
	^ self new
		piece: aPiece;
		yourself! !

!PInstanceCreationStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:48'!
printOn: aStream
	aStream nextPutAll: 'create: '.
	piece printOn: aStream! !

PStep subclass: #PLookUpStep
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PLookUpStep class methodsFor: 'instance creation' stamp: 'RL 12/29/2011 14:42'!
on: aPiece with: selector
	^ self new
		piece: aPiece;
		selector: selector;
		yourself! !

!PLookUpStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:48'!
printOn: aStream
	aStream
		nextPutAll: 'looking up: #';
		nextPutAll: selector
	! !

!PLookUpStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:42'!
selector
	^ selector! !

!PLookUpStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:42'!
selector: aSelector
	selector := aSelector! !

PStep subclass: #PSearchingStep
	instanceVariableNames: 'classOrPerspective'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PSearchingStep class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:44'!
on: aPiece with: aClassOrPerspective
	^ self new
		piece: aPiece;
		classOrPerspective: aClassOrPerspective;
		yourself! !

!PSearchingStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:44'!
classOrPerspective
	^ classOrPerspective! !

!PSearchingStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:44'!
classOrPerspective: aClassOrPerspective
	classOrPerspective := aClassOrPerspective! !

!PSearchingStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:50'!
printOn: aStream
	aStream
		nextPutAll: 'searching in: ';
		nextPutAll: classOrPerspective name
	! !

!PStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:41'!
piece
	^ piece! !

!PStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:40'!
piece: aPiece
	piece := aPiece! !

Object subclass: #PStepList
	instanceVariableNames: 'steps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:17'!
addStep: aPLookupStep
	steps add: aPLookupStep! !

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:17'!
initialize
	super initialize.
	steps := OrderedCollection new! !

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:19'!
size
	^ steps size! !

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:18'!
steps
	^ steps! !

Object subclass: #PerspectiveLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

PerspectiveLayer class
	instanceVariableNames: 'parentLayer'!

PerspectiveLayer class
	instanceVariableNames: 'parentLayer'!

!PerspectiveLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/7/2011 12:09'!
hasParentLayer
	^ parentLayer notNil! !

!PerspectiveLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:54'!
initialParentLayer
	"subclasses should override this and return the initial parent layer to be used upon class creation"
	^ nil! !

!PerspectiveLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/7/2011 11:56'!
new
	self shouldNotImplement! !

!PerspectiveLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:54'!
parentLayer
	^ parentLayer ifNil: [ self initialParentLayer ]! !

!PerspectiveLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:13'!
parentLayer: aLayer
	(aLayer inheritsFrom: PerspectiveLayer)
		ifTrue: [ parentLayer := aLayer ]
		ifFalse: [ self error: 'parentLayer has to be a subclass of PerspectiveLayer' ]! !

PerspectiveLayer subclass: #TestChildLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:54'!
initialParentLayer
	^ TestLayer! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:45'!
isTestChildLayer
	^ true! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:13'!
method1
	<pragma: #hide>! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 18:29'!
newMethod
	^ 2! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 18:25'!
returnValue
	^ 15! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:55'!
someValue
	^ self proceed * 2! !

PerspectiveLayer subclass: #TestLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:44'!
isTestLayer
	^ true! !

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 17:19'!
returnValue
	^ 23! !

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:55'!
someValue
	^ 100! !

Object subclass: #PerspectiveMethodWrapper
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PerspectiveMethodWrapper class methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:04'!
for: aCompiledMethod
	^ self new
		method: aCompiledMethod;
		yourself! !

!PerspectiveMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 15:12'!
doesNotUnderstand: aMessage
	^ aMessage sendTo: method! !

!PerspectiveMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 15:07'!
method
	^ method! !

!PerspectiveMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 15:07'!
method: aCompiledMethod
	method := aCompiledMethod! !

!PerspectiveMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:06'!
run: selector with: arguments in: receiver
	^ receiver methodDispatcher
		on: receiver
		perform: selector
		withArguments: arguments! !

!PerspectiveMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 17:34'!
selector
	^ method selector! !

!PerspectiveMethodWrapper methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 18:10'!
selector: aSelector
	"ignore"
! !

Object subclass: #PerspectiveObject
	instanceVariableNames: 'methodDispatcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PerspectiveObject class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:12'!
basicAddSelector: selector withMethod: compiledMethod
	(self ~= PerspectiveObject and: [ PerspectiveObject includesSelector: selector ])
		ifTrue: [ ^ self error: 'You mustn''t override this method' ].
	^ super
		basicAddSelector: selector
		withMethod: (self = PerspectiveObject
			ifTrue: [ compiledMethod ]
			ifFalse: [ self wrapMethod: compiledMethod ])! !

!PerspectiveObject class methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:04'!
wrapMethod: aCompiledMethod
	^ PerspectiveMethodWrapper for: aCompiledMethod! !

!PerspectiveObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 11:50'!
= anObject
	^ anObject class = Piece
		ifTrue: [ anObject = self ]
		ifFalse: [ self == anObject ]! !

!PerspectiveObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 11:45'!
@ aPerspectiveLayer
	^ Piece for: self in: aPerspectiveLayer! !

!PerspectiveObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:12'!
methodDispatcher
	^ methodDispatcher ifNil: [ methodDispatcher := DefaultMethodDispatcher for: self class ]! !

!PerspectiveObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:12'!
methodDispatcher: aMethodLookup
	methodDispatcher := aMethodLookup! !

!PerspectiveObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:56'!
proceed
	^ methodDispatcher proceed! !

PerspectiveObject subclass: #PerspectiveObject1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!PerspectiveObject1 methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 23:55'!
callReturnValue
	^ self returnValue! !

!PerspectiveObject1 methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:13'!
method1
	"not hidden"! !

!PerspectiveObject1 methodsFor: 'as yet unclassified' stamp: 'RL 12/5/2011 02:31'!
returnValue
	^ 42! !

Object subclass: #PieceImplementation
	instanceVariableNames: 'object methodDispatcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

PieceImplementation class
	instanceVariableNames: 'instanceCreatedSignal signalsEnabled'!

PieceImplementation class
	instanceVariableNames: 'instanceCreatedSignal signalsEnabled'!

!PieceImplementation class methodsFor: 'instance creation' stamp: 'RL 12/14/2011 15:14'!
for: anObject in: aPerspective
	^ self new
		initializeOnObject: anObject andPerspective: aPerspective! !

!PieceImplementation methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:16'!
handleMessage: aMessage
	^ methodDispatcher
		sendMessage: aMessage
		to: object! !

!PieceImplementation methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:07'!
initializeOnObject: anObject andPerspective: aPerspective
	object := anObject.
	methodDispatcher := PerspectiveMethodDispatcher for: anObject class from: aPerspective.
	^ self! !

!PieceImplementation methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:06'!
methodDispatcher
	^ methodDispatcher! !

!PieceImplementation methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 15:11'!
object
	^ object! !

!PieceImplementation methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:52'!
perspective
	^ methodDispatcher perspective! !

ScrollPane subclass: #PStepsPane
	instanceVariableNames: 'steps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PStepsPane class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:27'!
on: aPStepList
	^ self new
		steps: aPStepList;
		yourself! !

!PStepsPane methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:02'!
initialize
	super initialize.
	1 to: 7 do: [ :i | | m |
		m := PPieceMorph new.
		m position: (i-1*205)@10.
		m extent: 200@200.
		self scroller addMorph: m
	]! !

!PStepsPane methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:23'!
selectStep: anIndex! !

!PStepsPane methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:22'!
steps: stepList
	steps := stepList! !

ProtoObject subclass: #Piece
	instanceVariableNames: 'implementation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

Piece class
	instanceVariableNames: 'instanceCreatedSignal'!

Piece class
	instanceVariableNames: 'instanceCreatedSignal'!

!Piece class methodsFor: 'signals' stamp: 'RL 12/14/2011 14:18'!
disconnect: anId
	self instanceCreatedSignal disconnect: anId! !

!Piece class methodsFor: 'instance creation' stamp: 'RL 12/29/2011 14:12'!
for: anObject in: aPerspective
	| impl newInstance |
	impl := PieceImplementation for: anObject in: aPerspective.
	newInstance := super new pieceImplementation: impl.
	self instanceCreated: newInstance.
	^ newInstance! !

!Piece class methodsFor: 'signals' stamp: 'RL 12/29/2011 14:12'!
instanceCreated: anInstance
	self instanceCreatedSignal emitWith: anInstance! !

!Piece class methodsFor: 'signals' stamp: 'RL 12/14/2011 14:14'!
instanceCreatedSignal
	^ instanceCreatedSignal ifNil: [ instanceCreatedSignal := PSignal new ]! !

!Piece class methodsFor: 'instance creation' stamp: 'RL 12/14/2011 14:28'!
new
	self shouldNotImplement! !

!Piece class methodsFor: 'signals' stamp: 'RL 12/14/2011 14:14'!
onInstanceCreation: aBlock
	^ self instanceCreatedSignal connect: aBlock! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 15:44'!
asString
	^ self printString! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 15:44'!
asStringOrText
	^ self printString! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 15:16'!
doesNotUnderstand: aMessage
	^ implementation handleMessage: aMessage! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 17:32'!
inspect
	ToolSet inspect: self! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:12'!
pieceImplementation
	^ implementation! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:12'!
pieceImplementation: aPieceImplementation
	implementation := aPieceImplementation! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:31'!
printOn: aStream
	aStream
		nextPutAll: implementation object asString;
		nextPutAll: '@';
		nextPutAll: implementation perspective asString! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:31'!
printString
	^ String streamContents: [ :stream | self printOn: stream ].! !

!Piece methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:17'!
printStringLimitedTo: limit
	"Answer a String whose characters are a description of the receiver.
	If you want to print without a character limit, use fullPrintString."
	| limitedString |
	limitedString := String streamContents: [:s | self printOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , '...etc...'! !
